function [alpha, Xbeam, Ybeam] = calcDeflection (X1, Y1, X2, Y2, X3, Y3, r)
% Beam deflection
ECNT=100e9; %(100GPa)
Di=6e-9; %(6nm)
Do=10e-9; %(10nm)
ICNT=pi/64*(Do^4-Di^4);
LCNT=sqrt((Y2-Y1)^2+(X2-X1)^2);
beta=1;  %(180-contact angle)/90; %rotation
%theta=atan(abs(X3-X2)/abs(Y2-Y3)); %contact angle
%Py=r*sin(theta);
lambda=0.01*LCNT^2;%Py*LCNT^2/(ECNT*ICNT)
phio=pi/2;
%alpha=40*pi/180;
alphad=0;
for ibeam=1:3600;
    alphad=alphad+0.1;
    alpha=alphad*pi/180;
    k=sqrt(0.5-0.5*sin(beta*alpha-alpha));
    fkphio=ellipke(k^2);
    fkphil=fkphio-sqrt(lambda);
    [SN,CN,DN] = ellipj(fkphil,k^2);
    phil=asin(SN);
    alpha2=(pi-4*asin(k*SN))/(2*beta);
    epsilon=alpha2-alpha;
    if (epsilon<0.0001) 
        break 
    end
end
% at this step alpha, the beam deflection at end point is determined.
% next the shape of the bent curve will be calculated
% construct phi vector
phistep=(pi/2-phil)/100;
phi=zeros(1,101);
epspaper=zeros(1,101);
for iphi=1:101;
    phivalue=phil+(iphi-1)*phistep;
    epsvalue=0+(iphi-1)*0.01;
    phi(iphi)=phivalue;
    epspaper(iphi)=epsvalue;
end
coeffx=[cos(beta*alpha)   -sin(beta*alpha)];
coeffy=[sin(beta*alpha)    cos(beta*alpha)];
philvector=phil*ones(1,101);
G=2*k*(cos(philvector)-cos(phi))/sqrt(lambda);
k2vector=k^2*ones(1,101);
[F1phi,E2phi,Z2phi]=elliptic12(phi,k2vector);
[F1phil,E2phil,Z2phil]=elliptic12(philvector,k2vector);
H=epspaper-2*(E2phi-E2phil)/sqrt(lambda);
GH=[G;H];
Xbeam=coeffx*GH*LCNT;
Ybeam=coeffy*GH*LCNT;
%alphad = alpha*180/pi;
% dX = Xbeam(101)*LCNT;
% dY = Ybeam(101)*LCNT;