function [stiffness,force,contactelement, epspn]=formStiffness2Dframe(GDof,numberElements,elementNodes,numberNodes,xx,yy,EI,EA,cfn,Xcoordfn,Ycoordfn,cfan,cfo,Xcoordfo,Ycoordfo,cfao,force,momentn,momento);
stiffness=zeros(GDof);
% computation of the system stiffness matrix
for e=1:numberElements;
% elementDof: element degrees of freedom (Dof)
indice=elementNodes(e,:) ;
elementDof=[ indice indice+numberNodes indice+2*numberNodes] ;
nn=length(indice); %number of nodes
xa=xx(indice(2))-xx(indice(1)); %delta x element
ya=yy(indice(2))-yy(indice(1)); % delta y element
length_element=sqrt(xa*xa+ya*ya);
 if (Ycoordfn < yy(indice(2)) & Ycoordfn >= yy(indice(1)))
     contactelement=e;
xmidn=xx(indice(1))+0.5*xa;
ymidn=yy(indice(1))+0.5*ya;
signepsparametern=sign(Ycoordfn-ymidn);
epspn=signepsparametern*sqrt((Xcoordfn-xmidn)^2+(Ycoordfn-ymidn)^2)/(2*length_element);
    force(elementDof(1))=force(elementDof(1))+cfn*cos(cfan)*0.25*(2-3*epspn+epspn^2);
    force(elementDof(2))=force(elementDof(2))+cfn*cos(cfan)*0.25*(2+3*epspn-epspn^2);
    force(elementDof(3))=force(elementDof(3))+cfn*sin(cfan)*0.25*(2-3*epspn+epspn^2);
    force(elementDof(4))=force(elementDof(4))+cfn*sin(cfan)*0.25*(2+3*epspn-epspn^2);
    force(elementDof(5))=force(elementDof(5))+momentn*0.25*(1-epspn-epspn^2+epspn^3);
    force(elementDof(6))=force(elementDof(6))+momentn*0.25*(-1-epspn+epspn^2+epspn^3);
end
if (Ycoordfo < yy(indice(2)) & Ycoordfo >= yy(indice(1)))
xmido=xx(indice(1))+0.5*xa;
ymido=yy(indice(1))+0.5*ya;
signepsparametero=sign(Ycoordfo-ymido);
epspo=signepsparametero*sqrt((Xcoordfo-xmido)^2+(Ycoordfo-ymido)^2)/(2*length_element);
    force(elementDof(1))=force(elementDof(1))-cfo*cos(cfao)*0.25*(2-3*epspo+epspo^2);
    force(elementDof(2))=force(elementDof(2))-cfo*cos(cfao)*0.25*(2+3*epspo-epspo^2);
    force(elementDof(3))=force(elementDof(3))-cfo*sin(cfao)*0.25*(2-3*epspo+epspo^2);
    force(elementDof(4))=force(elementDof(4))-cfo*sin(cfao)*0.25*(2+3*epspo-epspo^2);
    force(elementDof(5))=force(elementDof(5))-momento*0.25*(1-epspo-epspo^2+epspo^3);
    force(elementDof(6))=force(elementDof(6))-momento*0.25*(-1-epspo+epspo^2+epspo^3);
end
cosa=xa/length_element;
sena=ya/length_element;
ll=length_element;
L= [cosa*eye(2) sena*eye(2) zeros(2);
-sena*eye(2) cosa*eye(2) zeros(2);
zeros(2,4) eye(2)];
oneu=[1 -1;-1 1];
oneu2=[1 -1;1 -1];
oneu3=[1 1;-1 -1];
oneu4=[4 2;2 4];
k1=[EA/ll*oneu zeros(2,4);
zeros(2) 12*EI/ll^3*oneu 6*EI/ll^2*oneu3;
zeros(2) 6*EI/ll^2*oneu2 EI/ll*oneu4];
stiffness(elementDof,elementDof)=stiffness(elementDof,elementDof)+L'*k1*L;
%force(elementDof)=force(elementDof)+fn'+fo';
end