function [alpha, dX, dY, Xbeam, Ybeam] = frame2d (xBeam, yBeam, x1, y1, x2, y2, x3, y3, x4, y4, r, BC, NoE, I);
% E; modulus of elasticity
% I: second moment of area
% L: length of bar
E=210000; A=1e11; EA=E*A; EI=E*I;
numberElements=NoE;
%from interface migration program
Xcoordfn=x1;
Ycoordfn=y1;
Xcoordfo=x3;
Ycoordfo=y3;
Xsurfacen=x2;
Ysurfacen=y2;
Xsurfaceo=x4;
Ysurfaceo=y4;
Xcontactn=Xcoordfn;
Ycontactn=Ycoordfn;
Xcontacto=Xcoordfo;
Ycontacto=Ycoordfo;
momentn=0;
momento=0;
cfn=2.1e11;%concentratedforcenew (supposed to be r)
cfo=2.1e11;%concentratedforceold (supposed to be r)
% generation of coordinates and connectivities
xx=xBeam;
yy=yBeam;

for i=1:numberElements;
elementNodes(i,1)=i;
elementNodes(i,2)=i+1;
end
numberNodes=numberElements+1;


% for structure:
% displacements: displacement vector
% force : force vector
% stiffness: stiffness matrix
% GDof: global number of degrees of freedom
GDof=3*numberNodes;
U=zeros(GDof,1);
force=zeros(GDof,1);
%force vector
% concentrated load

cfpn=[Xcoordfn,Ycoordfn];%concentratedforcepositionnew from orgin
cfan=atan2((Ysurfacen-Ycontactn),(Xsurfacen-Xcontactn));%concentratedforceanglenew global angle

cfpo=[Xcoordfo,Ycoordfo];%concentratedforcepositionold from origin
cfao=atan2((Ysurfaceo-Ycontacto),(Xsurfaceo-Xcontacto));%concentratedforceangleold global angle

% stiffness matrix
[stiffness,force,contactelement, epspn]=...
formStiffness2Dframe(GDof,numberElements,elementNodes,numberNodes,xx,yy,EI,EA,cfn,Xcoordfn,Ycoordfn,cfan,cfo,Xcoordfo,Ycoordfo,cfao,force,momentn,momento);
% boundary conditions and solution
%prescribedDof=[1 2+numberElements 1+2*(1+numberElements)]';%
prescribedDof = BC;
%prescribedDof=[1 1+numberElements 2+numberElements 1+2*(1+numberElements) ]';
% solution
displacements=solution(GDof,prescribedDof,stiffness,force);
% output displacements/reactions
outputDisplacementsReactions(displacements,stiffness,GDof,prescribedDof);
% drawing undeformed and deformed meshes
U=displacements;
alpha=atan2((yy(contactelement+1)+U(numberNodes+contactelement+1)-yy(contactelement)-U(numberNodes+contactelement)),(xx(contactelement+1)+U(contactelement+1)-xx(contactelement)-U(contactelement)));
Xbeam = xx+U(1:numberNodes)';
Ybeam = yy+U(numberNodes+1:2*numberNodes)';
dX = U(contactelement+1)/4*(2+3*epspn-epspn^2)+U(contactelement)/4*(2-3*epspn+epspn^2);
dY = U(numberNodes+contactelement+1)/4*(2+3*epspn-epspn^2)+U(numberNodes+contactelement)/4*(2-3*epspn+epspn^2);
X = Xcoordfn + dX;
Y = Ycoordfn + dY;
%plot(nodeCoordinatesyy,U(1:numberNodes)');grid;
%figure
%plot(xx+U(1:numberNodes)',yy+U(numberNodes+1:2*numberNodes)');